
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *tSquare2D_class;
void *tSquare2D_class;

typedef struct _tSquare2D {
  t_object  x_obj;

// pd code: 
//   t_float  Xmin, Xmax, Ymin, Ymax;
  float  Xmin, Xmax, Ymin, Ymax;
  //extrem =  Xmin, Ymin, Xmax, Ymax;

// pd code: 
//   t_outlet *force_new;// outlet
  void *force_new;// outlet
} t_tSquare2D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void tSquare2D_position2D(t_tSquare2D *x, double X, double Y);
void tSquare2D_Xmin(t_tSquare2D *x, double X);
void tSquare2D_Xmax(t_tSquare2D *x, double X);
void tSquare2D_Ymin(t_tSquare2D *x, double X);
void tSquare2D_Ymax(t_tSquare2D *x, double X);
void *tSquare2D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void tSquare2D_position2D(t_tSquare2D *x, t_float X, t_float Y)
void tSquare2D_position2D(t_tSquare2D *x, double X, double Y)
{

 	if ((X > x->Xmin) & (X < x->Xmax) & (Y > x->Ymin) & (Y < x->Ymax))
	{
		outlet_float(x->force_new, 1);
	}
	else
	{
		outlet_float(x->force_new, 0);
	}
}


// pd code: 
// void tSquare2D_Xmin(t_tSquare2D *x, t_float X)
void tSquare2D_Xmin(t_tSquare2D *x, double X)
{
   x->Xmin= X;
}


// pd code: 
// void tSquare2D_Xmax(t_tSquare2D *x, t_float X)
void tSquare2D_Xmax(t_tSquare2D *x, double X)
{
   x->Xmax= X;
}


// pd code: 
// void tSquare2D_Ymin(t_tSquare2D *x, t_float X)
void tSquare2D_Ymin(t_tSquare2D *x, double X)
{
   x->Ymin= X;
}


// pd code: 
// void tSquare2D_Ymax(t_tSquare2D *x, t_float X)
void tSquare2D_Ymax(t_tSquare2D *x, double X)
{
   x->Ymax= X;
}

void *tSquare2D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_tSquare2D *x = (t_tSquare2D *)pd_new(tSquare2D_class);
  t_tSquare2D *x = (t_tSquare2D *)newobject(tSquare2D_class);

// pd code: ***UNCHANGED*** 
//   x->force_new=outlet_new(&x->x_obj, 0);
x->force_new=outlet_new(&x->x_obj, 0);


  if (argc>=4)
    x->Ymax = atom_getfloatarg(3, argc, argv);
  else
    x->Ymax = 1;

  if (argc>=3)
    x->Ymin = atom_getfloatarg(2, argc, argv);
  else
    x->Ymin = -1;

  if (argc>=2)
    x->Xmax = atom_getfloatarg(1, argc, argv);
  else
    x->Xmax = 1;

  if (argc>=1)
    x->Xmin = atom_getfloatarg(0, argc, argv);
  else
    x->Xmin = -1;

  return (x);
}


// pd code: 
// void tSquare2D_setup(void) 
int main(void)
{

// pd code 
/*
  tSquare2D_class = class_new(gensym("tSquare2D"),
        (t_newmethod)tSquare2D_new,
        0, sizeof(t_tSquare2D),
        CLASS_DEFAULT, A_GIMME, 0);*/
setup((t_messlist **) &tSquare2D_class,(method)tSquare2D_new,0,(short)sizeof(t_tSquare2D),0L, A_GIMME,0);



// pd code: 
//   class_addcreator((t_newmethod)tSquare2D_new, gensym("pmpd.tSquare2D"), A_GIMME, 0);
  // class_addcreator ((t_newmethod)tSquare2D_new, gensym("pmpd.tSquare2D"), A_GIMME, 0);


// pd code: 
//   class_addmethod(tSquare2D_class, (t_method)tSquare2D_position2D, gensym("position2D"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tSquare2D_position2D, "position2D", A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addmethod(tSquare2D_class, (t_method)tSquare2D_Xmin, gensym("setXmin"), A_DEFFLOAT, 0);
addmess((method)tSquare2D_Xmin, "setXmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSquare2D_class, (t_method)tSquare2D_Ymin, gensym("setYmin"), A_DEFFLOAT, 0);
addmess((method)tSquare2D_Ymin, "setYmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSquare2D_class, (t_method)tSquare2D_Xmax, gensym("setXmax"), A_DEFFLOAT, 0);
addmess((method)tSquare2D_Xmax, "setXmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tSquare2D_class, (t_method)tSquare2D_Ymax, gensym("setYmax"), A_DEFFLOAT, 0);
addmess((method)tSquare2D_Ymax, "setYmax", A_DEFFLOAT, 0);

return 0;
}
